import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

export default defineConfig({
  // 告诉 Vite，所有静态资源都要加前缀 `/ide/proxy/5173/`
  base: '/ide/proxy/5173/',

  server: {
    // 让 Vite 监听 0.0.0.0 以便容器外部可以访问
    host: '0.0.0.0',
    // 设置端口为 5173
    port: 5173,
    // Vite4.x会校验请求域名，不在白名单会被拦截
    allowedHosts: ['genlitex-test-01.cn'],
    // 如果想干脆全允许： allowedHosts: 'all'
  },

  plugins: [vue()]
})
